#!/bin/env python
# vim:fileencoding=utf-8:ft=python
#
# Display weather from wetteronline.de
#
import gtk, cairo, urllib, re, gobject, sys, os

# -- Hier das Wetter entsprechend der URL auf wetteronline.de eintragen --
CITY="Niedersachsen/Lueneburg"

# Load images ########################################################
class _AppURLopener(urllib.FancyURLopener):
    version = "Mozilla/5.0"
urllib._urlopener = _AppURLopener()
def _loadImage(url):
	data = urllib.urlopen(url).read()
	loader = gtk.gdk.PixbufLoader()
	loader.write(data)
	loader.close()
	image = gtk.Image()
	image.set_from_pixbuf(loader.get_pixbuf())
	return image

# Load day ###########################################################
def _loadTable():
	try:
		url = "http://www.wetteronline.de/%s.htm" % CITY
		data = urllib.urlopen(url).read()
		url = "http://www.wetteronline.de" + re.search("\/cgi-bin[^\"]+", data).group(0)
		url = url.replace("region", "citybild")
		data = urllib.urlopen(url).read()
		data = re.search("<table[^>]+BGCOLOR.+?>(?s).+?<\/table>", data).group(0)
	except:
		print "Failed to load data from wetteronline"
		print " - Are you online?"
		print " - Maybe wetteronline changed their page design :/"
		sys.exit(1)

	table = gtk.Table()
	c = 0
	for day in re.findall("(?i)<b>([a-z]{2}, [0-9]+\.[0-9]+\.)<\/b>", data):
		table.attach(gtk.Label(day), c, c + 1, 0, 1)
		c += 1
	c = 0
	temps = re.findall("([0-9]+)&deg;C", data)
	for temp in (0, 1, 2):
		table.attach(gtk.Label(temps[temp] + "-" + temps[temp + 3] + u"°C"), c, c + 1, 1, 2)
		c += 1
	c = 0
	for image in re.findall("\/daten\/symbole\/vorhersagen\/standard\/[^\"]+", data)[:9]:
		url = "http://www.wetteronline.de" + image
		table.attach(_loadImage(url), c % 3, (c % 3) + 1, c / 3 + 2, c / 3 + 3)
		c += 1
	return table

## PLUGIN FUNCTIONS ##################################################
def initialize():
	widget.add(_loadTable())
	window.show_all()
